# Introduction

Fluence is an open protocol and a framework for internet or private cloud applications. Fluence provides a peer-to-peer development stack so that you can create applications free of proprietary cloud platforms, centralized APIs, and untrustworthy third-parties. The Fluence stack is open source and is maintained and governed by a community of developers.

At the core of Fluence is the open-source language **Aqua** that allows for the programming of peer-to-peer scenarios separately from the computations on peers. Applications are turned into hostless workflows over distributed function calls, which enables various levels of decentralization: from handling by a limited set of servers to complete peer-to-peer architecture by connecting user devices directly.

{% embed url="https://youtu.be/dIUXgdEcUPg" %}
Approaching Web3 development with Aqua language
{% endembed %}

{% embed url="https://youtu.be/M_u-EnWrMOQ" %}

This book is dedicated to all things Aqua and currently in its **alpha** version and we expect to expand both Aqua's breadth and depth coverage over the coming weeks.&#x20;

Stay in touch or contact us via the following channels:&#x20;

* [Discord](https://discord.gg)
* [Telegram](https://t.me/fluence\_project)
* [Aqua Github](https://github.com/fluencelabs/aqua)
* [Youtube](https://www.youtube.com/channel/UC3b5eFyKRFlEMwSJ1BTjpbw)





